// Copyright 2019 getensh.com. All rights reserved.
// Use of this source code is governed by getensh.com.
package apis

type BiGetDashReq struct {
}

type BiDashVehicle struct {
	Count    int64 `json:"count"`
	Increase int64 `json:"increase"`
}

type BiDashCharge struct {
	Charge     int64   `json:"charge"`
	ChargeRate float64 `json:"charge_rage"`
	Increase   float64 `json:"increase"`
}

type BiDashFail struct {
	Fail     int64   `json:"fail"`
	FailRate float64 `json:"fail_rate"`
	Increase float64 `json:"increase"`
}

type BiDash struct {
	VehicleInfo BiDashVehicle `json:"vehicle_info"`
	ChargeInfo  BiDashCharge  `json:"charge_info"`
	FailInfo    BiDashFail    `json:"fail_info"`
}

type BiGetDashReply struct {
	DashInfo BiDash `json:"dash_info"`
}

type BiGetServiceStatusReq struct {
	StartTimestamp int64 `json:"start_timestamp"`
	EndTimestamp   int64 `json:"end_timestamp"`
	MerchantId     int64 `json:"merchant_id"`
	ApiId          int64 `json:"api_id"`
}

type ServiceStatus struct {
	TimestampMinute int64   `json:"timestamp_minute"`
	FailCount       int     `json:"fail_count"`
	AvgElapsed      float64 `json:"avg_elapsed"`
}

type BiGetServiceStatusReply struct {
	Infos []ServiceStatus `json:"infos"`
}

type BiGetProviderServiceStatusReq struct {
	StartTimestamp int64 `json:"start_timestamp"`
	EndTimestamp   int64 `json:"end_timestamp"`
	ProviderApiId  int64 `json:"provider_api_id"`
}

type BiGetProviderServiceStatusReply struct {
	Infos []ServiceStatus `json:"infos"`
}

type BiGetTrendReq struct {
	StartTimestamp int64 `json:"start_timestamp"`
	EndTimestamp   int64 `json:"end_timestamp"`
	MerchantId     int64 `json:"merchant_id"`
	ApiId          int64 `json:"api_id"`
}

type Trend struct {
	Date   string `json:"date"`
	Total  int64  `json:"total"`
	Charge int64  `json:"charge"`
}

type BiGetTrendReply struct {
	Infos              []Trend `json:"infos"`
	TotalMax           int64   `json:"total_max"`
	TotalAvg           int64   `json:"total_avg"`
	TotalCurrent       int64   `json:"total_current"`
	ChargeMax          int64   `json:"charge_max"`
	ChargeAvg          int64   `json:"charge_avg"`
	ChargeCurrent      int64   `json:"charge_current"`
	LastStageTotalAvg  int64   `json:"last_stage_total_avg"`
	LastStageChargeAvg int64   `json:"last_stage_charge_avg"`
}

type BiGetProviderTrendReq struct {
	StartTimestamp   int64 `json:"start_timestamp"`
	EndTimestamp     int64 `json:"end_timestamp"`
	ProviderApiId    int64 `json:"provider_api_id"`
	ProviderApiIdNew int64 `json:"provider_api_id_new"`
}

type BiGetProviderTrendReply struct {
	Infos              []Trend `json:"infos"`
	TotalMax           int64   `json:"total_max"`
	TotalAvg           int64   `json:"total_avg"`
	TotalCurrent       int64   `json:"total_current"`
	ChargeMax          int64   `json:"charge_max"`
	ChargeAvg          int64   `json:"charge_avg"`
	ChargeCurrent      int64   `json:"charge_current"`
	LastStageTotalAvg  int64   `json:"last_stage_total_avg"`
	LastStageChargeAvg int64   `json:"last_stage_charge_avg"`
}

type BiGetReportReq struct {
	Date              []string `json:"date"`
	MerchantId        int64    `json:"merchant_id"`
	MerchantIds       []int64  `json:"merchant_ids"`
	ApiId             []int64  `json:"api_id"`
	PageNumber        int      `json:"page_number"`
	PageSize          int      `json:"page_size"`
	TodayEndTimestamp int64    `json:"today_end_timestamp"`
	IsAll             bool     `json:"is_all"`
}

type BiReportInfo struct {
	MerchantName      string `json:"merchant_name"`
	Date              string `json:"date"`
	ApiName           string `json:"api_name"`
	Total             int64  `json:"total"`
	Valid             int64  `json:"valid"`
	ValidRate         string `json:"valid_rate"`
	QueryNoRecord     int64  `json:"query_no_record"`
	QueryNoRecordRate string `json:"query_no_record_rate"`
	Fail              int64  `json:"fail"`
	FailRate          string `json:"fail_rate"`
	Charge            int64  `json:"charge"`
	ChargeRate        string `json:"charge_rate"`
	AvgElapsed        string `json:"avg_elapsed"`
	Reuse             int64  `json:"reuse"`
	Success           int64  `json:"-"`
	ApiId             int64  `json:"-"`
	ReuseRate         string `json:"reuse_rate"`
}

type BiProviderReportInfo struct {
	ProviderName      string `json:"provider_name"`
	Date              string `json:"date"`
	ProviderApiName   string `json:"provider_api_name"`
	Total             int64  `json:"total"`
	QueryNoRecord     int64  `json:"query_no_record"`
	QueryNoRecordRate string `json:"query_no_record_rate"`
	Fail              int64  `json:"fail"`
	FailRate          string `json:"fail_rate"`
	Charge            int64  `json:"charge"`
	ChargeRate        string `json:"charge_rate"`
	AvgElapsed        string `json:"avg_elapsed"`
	ProviderApiId     int64  `json:"provider_api_id"`
}

type BiGetReportReply struct {
	PageSize int            `json:"page_size"`
	Total    int            `json:"total"`
	Infos    []BiReportInfo `json:"bi_report_info"`
	Sum      BiReportInfo   `json:"sum"`
}

type BiGetProviderReportReq struct {
	Date              []string `json:"date"`
	ProviderApiId     []int64  `json:"provider_api_id"`
	ProviderId        int64    `json:"provider_id"`
	PageNumber        int      `json:"page_number"`
	ProviderApiIdNew  []int64  `json:"provider_api_id_new"`
	TodayEndTimestamp int64    `json:"today_end_timestamp"`
	IsAll             bool     `json:"is_all"`
	PageSize          int      `json:"page_size"`
}

type BiGetProviderReportReply struct {
	Total    int                    `json:"total"`
	PageSize int                    `json:"page_size"`
	Infos    []BiProviderReportInfo `json:"infos"`
	Sum      BiProviderReportInfo   `json:"sum"`
}

type BiGetDistributionReq struct {
	ApiId          int64 `json:"api_id"`
	MerchantId     int64 `json:"merchant_id"`
	StartTimestamp int64 `json:"start_timestamp"`
	EndTimestamp   int64 `json:"end_timestamp"`
	PageNumber     int   `json:"page_number"`
}

type CodeCount struct {
	Code  string `json:"code"`
	Msg   string `json:"msg"`
	Count int    `json:"count"`
}
type ProviderCount struct {
	ProviderApiName string `json:"provider_api_name"`
	ProviderName    string `json:"provider_name"`
	Count           int    `json:"count"`
	Success         int    `json:"success"`
	Query           int    `json:"query"`
}

type BiDistribution struct {
	ApiCodeTotal int64           `json:"api_code_total"`
	ApiValid     int             `json:"api_valid"`
	ApiCharge    int             `json:"api_charge"`
	ApiSuccess   int             `json:"api_success"`
	ApiCodeList  []CodeCount     `json:"api_code_list"`
	ProviderList []ProviderCount `provider_list`
}

type BiProviderDistribution struct {
	ProviderCharge    int         `json:"provider_charge"`
	ProviderSuccess   int         `json:"provider_success"`
	ProviderCodeTotal int         `json:"provider_code_total"`
	ProviderCodeList  []CodeCount `json:"provider_code_list"`
}

type BiGetDistributionReply struct {
	Info BiDistribution `json:"info"`
}

type BiGetProviderDistributionReq struct {
	ProviderApiId  int64 `json:"provider_api_id"`
	StartTimestamp int64 `json:"start_timestamp"`
	EndTimestamp   int64 `json:"end_timestamp"`
}
type BiGetProviderDistributionReply struct {
	Info BiProviderDistribution `json:"info"`
}
