// Copyright 2019 getensh.com. All rights reserved.
// Use of this source code is governed by getensh.com.

package apis

// 记录接收回调日志
type LogCallbackInReq struct {
	ServiceType    int     `json:"service_type" description:"业务类型，101：维保记录"`
	SourceName     string  `json:"source_name" description:"数据源名称"`
	SourceObjectId string  `json:"source_object_id" description:"数据源对象id，如：order_id"`
	RequestCode    int     `json:"request_code" description:"请求结果码，同request_params.code，1表示已出报告"`
	RequestParams  string  `json:"request_params" description:"请求参数"`
	ResponseParams string  `json:"response_params" description:"响应参数"`
	Elapsed        float64 `json:"elapsed" description:"调用耗时，单位：秒"`
}

type LogCallbackInReply struct {
}

// 记录发送回调日志
type LogCallbackOutReq struct {
	ServiceType    int     `json:"service_type" description:"业务类型，101：维保记录"`
	MerchantId     int     `json:"merchant_id" description:"下游商户id"`
	ObjectId       string  `json:"object_id" description:"关联的对象id，如：order_no"`
	RequestCode    int     `json:"request_code" description:"请求结果码，同request_params.code，0表示生成报告成功"`
	RequestParams  string  `json:"request_params" description:"请求参数"`
	ResponseParams string  `json:"response_params" description:"响应参数"`
	Elapsed        float64 `json:"elapsed" description:"调用耗时，单位：秒"`
	IsReuse        int     `json:"is_reuse" description:"是否复用，1：是，0：否"`
	Search         string  `json:"search" description:"搜索条件，维保业务时的值代表VIN码"`
}

type LogCallbackOutReply struct {
}
