package order

import (
	"context"
	"gd_service/apis"
	"encoding/json"
	"testing"
)

func Test_ServiceGetAnnualInspectionTime(t *testing.T) {
	req := apis.ServiceGetAnnualInspectionTimeReq{AppKey: "123456", PlateNo: "川A33E22"}
	reply := apis.ServiceGetAnnualInspectionTimeReply{}
	if err := xcli.Call(context.Background(), "ServiceGetAnnualInspectionTime", req, &reply); err != nil {
		t.Error("failed to call: ", err)
	} else {
		d, _ := json.Marshal(reply)
		t.Log(string(d))
	}
}

func Test_ServiceGetAnnualInspectionCity(t *testing.T) {
	req := apis.ServiceGetAnnualInspectionCityReq{AppKey: "123456"}
	reply := apis.ServiceGetAnnualInspectionCityReply{}
	if err := xcli.Call(context.Background(), "ServiceGetAnnualInspectionCity", req, &reply); err != nil {
		t.Error("failed to call: ", err)
	} else {
		d, _ := json.Marshal(reply)
		t.Log(string(d))
	}
}

func Test_ServiceGetAnnualInspectionStation(t *testing.T) {
	req := apis.ServiceGetAnnualInspectionStationReq{AppKey: "123456", CityName: "资阳市"}
	reply := apis.ServiceGetAnnualInspectionStationReply{}
	if err := xcli.Call(context.Background(), "ServiceGetAnnualInspectionStation", req, &reply); err != nil {
		t.Error("failed to call: ", err)
	} else {
		d, _ := json.Marshal(reply)
		t.Log(string(d))
	}
}
